#include <stdlib.h>
#include <sys/types.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/ipc.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>

#define ROZMIAR 40	/*rozmiar pamieci wspolnej*/
#define SHMKEY 4321	/*niepowtarzalny klucz pamieci wspolnej*/
#define SEMKEY 4444	/*niepowtarzalny klucz semafora*/

typedef union _semun {
    int	val;
    struct semid_ds *buf;
    ushort *array;
    } semun;	 

struct sembuf p_operacja;			//struktura systemowa
struct sembuf v_operacja;

extern etext, edata, end;

    int shmid;		//ID pamieci wspolnej
    int semid;		//ID zestawu semafow
    int status=0;		//wartos zwracana przez f. SEMOP
    int *adres;		//wskaznik na adres pamieci wspolnej


//Tworze pamiec wspolna:   ---------------------------------------------------------------
    int tworzenie_pamieci()
    {
//	printf("\nTworze pamiec: ");
	if((shmid=shmget(SHMKEY,ROZMIAR,IPC_CREAT|IPC_EXCL|0666)) == -1)
	    {
		if(errno == EEXIST) 
		    {
			shmid=shmget(SHMKEY,ROZMIAR,IPC_CREAT);
//			printf("NO\n  Pamiec wspolna juz istnieje:ID = %d", shmid);
		    }    
		else
		    {
			printf("NO\n  Blad tworzenia pamieci wspolnej: SHMGET");
			exit(1);
		    }
	    }
//	else printf("OK.  SHMID: %d", shmid);
    }


//Tworze zestaw semaforow:   -------------------------------------------------------------
    int tworzenie_semafora()
    {
//	printf("\nTworze zestaw semaforow: ");
	if((semid=semget(SEMKEY,1,IPC_CREAT|IPC_EXCL|0660)) == -1)
	    {
		if(errno == EEXIST) //gdy zestaw semaforow juz istnieje
		    {
			semid=semget(SEMKEY,1,0); //to zwtoc jego ID
//			printf("NO.\n  Zestaw semaforow juz istnieje, SEMID: %d", semid);
		    }
		else
		    printf("NO.\n  Blad utworzenia zestawu semaforow: SEMGET");
	    }    
	else	//jesli utworzony
	    {
		semun arg;	//tworze obiekt
		arg.val = 1;	//ustawienie wartosci celem ustawienia semafora
		if((status=semctl(semid,0,SETVAL,arg)) == -1)
		    {
			perror("NO.\n  Ustawienie zawartosci semafora nie udalo sie: SEMCTL");
			exit(2);
		    }
	    }	 
//	printf("OK.  SEMID: %d", semid);
    }		


//Operacja P-- (opuszczam semafor):   ----------------------------------------------------
     int  opuszczenie_semafora(int semid)
        {
//	    printf("\nOpuszczam semafor... ");
	    p_operacja.sem_num = 0;			//nr indeksu tablicy semaforow
	    p_operacja.sem_op = -1;			//jaka operacja na semaforze
	    p_operacja.sem_flg = SEM_UNDO;		//flaga operacji
	    if(semop(semid,&p_operacja,1) == -1)
		{
//		    perror("NO.\n  - Blad opuszczenia semafora: SEMOP");
		    exit(3);
		}
//	    printf("\n  - Wchodze do sekcji krytycznej!");
	}


//Przylaczam sie do pamieci wsponej:   ---------------------------------------------------
    int przylaczenie_pamieci(int shmid)
    {
//      printf("\n  - Przylaczam pamiec: ");
        if((adres = (int *) shmat(shmid,0,0)) == -1)
	{
//	    printf("NO\n     Blad przylaczenia do pamieci wspolnej: SHMAT");
	    exit(2);
	}
//	else printf("OK\n    Pamiec wspolna: %X, etext: %X, edata: %X, end %X", adres, &etext, &edata, &end);
//	printf("OK.");
    }


//Odlaczenie sie od pamieci wspolnej:   --------------------------------------------------
    void odlaczenie_pamieci()
    {
//        printf("\n  - Odlaczam pamiec: ");
        if(shmdt(adres) == -1)
    	{
    	    printf("NO\n    Blad odlaczenia od pamieci wspolnej: SHMDT");
	    exit(3);
	}
//        else printf("OK");
    }


//Operacja V++ (podnosze semafor):   -----------------------------------------------------
    int  podniesienie_semafora(int semid)
    {
//	printf("\n  - Podnosze semafor:");
	v_operacja.sem_num = 0;			//nr indeksu tablicy semaforow
	v_operacja.sem_op = 1;			//jaka operacja na semaforze
	v_operacja.sem_flg = SEM_UNDO;		//flaga operacji
	if(semop(semid,&v_operacja,1) == -1)	//wykonanie operacji
	{
//	    perror("\n    Blad podniesienia semafora: SEMOP");
	    exit(3);
	}
//	printf("\n  - Wychodze z sekcji krytycznej! :-)");
    }


//Usuniecie zestawu semaforow:   ---------------------------------------------------------
    int  usuniecie_semafor(int semid)
    {
//	printf("\nUsuwam semafor: ");
	if(semctl(semid,0,IPC_RMID) == -1)
	{
	    printf("NO.\nBlad usuniecia zestawu semaforow: SEMID=%d", semid);
	    exit(6);
	}
//	printf("OK.");    
    }


//Usuniecie pamieci wspolnej:   ----------------------------------------------------------
    int usuniecie_pamieci(int shmid)
    {
//        printf("\nUsuwam pamiec: ");
        if(shmctl(shmid, IPC_RMID, 0) == -1)
	{
	    printf("NO\n  Blad usuniecia pamieci wspolnej: SHMCTL");
	    exit(4);
	}
//      else printf("OK.");
    }
    

//Wypisanie bledu na monitorze:   --------------------------------------------------------
    void blad()
    {
	printf("\nPodano zla ilosc argumentow!");
	printf("\nPowinno byc:\n  arg1: nazwa programu (w),\n  arg2: polozenie windy nr1 (pietro 0-6),\n  arg3: predkosc windy nr1 (1-3 m/s),\n  arg4: polozenie windy nr2 (pietro 0-6),\n  arg5: predkosc windy nr2 (1-3 m/s)\n\n");
	exit(1);
    }
    
    void blad_klienta()
    {
	printf("\nPodano zla ilosc argumentow!");
	printf("\nPowinno byc:\n  arg1: nazwa programu (k),\n  arg2: z jakiego pietra Klient chce jechac(pietro 0-6),\n  arg3: na jakie pietro Klient chce jechac (pietro 0-6)\n\n");
	exit(1);
    }
